<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Students extends Controller_UserEnvi {

    public function action_index()
    {
        // VIEW
        $twig = Twig::factory('admin/students/index');
        $twig->Faculties = $this->getFaculties();
        $twig->Grades = $this->getGrades();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);        
    }
    
    public function action_add()
    {
        $twig = Twig::factory('admin/students/add');
        $twig->Faculties = $this->getFaculties();
        $twig->Grades = $this->getGrades();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    public function action_upload()
    {
        if(!empty($_FILES['students']) AND $this->request->method() == 'POST')
        {
            if($this->parseFile())
                $this->redirect('admin/students', 302);
        }
        // VIEW
        $twig = Twig::factory('admin/students/upload');
        $twig->Faculties = $this->getFaculties();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }

    public function action_edit()
    {
        $twig = Twig::factory('admin/students/edit');    
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    protected function parseFile()
    {
        $model = new Model_Admin_Students;
        $post = Arr::map('trim', $_POST);
        $facultyID = (int) $post['facultyID'];
        if(File::mime($_FILES["students"]["tmp_name"]) != 'text/plain')
            return false;
        $file = fopen($_FILES["students"]["tmp_name"], "r"); 
        $i = 0;
        while ($line = fgetcsv($file, 0, ";")) 
        {
                if($i > 0)
                {
                // Имя, фамилия, отчество
                $studentName = explode(' ', $line[0]); $idx = 0;
                if(UTF8::substr($studentName[1], 0, 1) == '(')
                {
                    $idx = 1;
                }
                $lastName = $studentName[0];
                $firstName = $studentName[1 + $idx];
                $secondName = '';
                for($i = 2 + $idx; $i < count($studentName); $i++)
                {
                    $secondName .= $studentName[$i].' ';
                }
                $secondName = trim($secondName);
                // Курс, степень подготовки
                $studentGradeNum = $line[1];
                switch($line[2])
                {
                    case 'Бакалавр':
                        $studentDegree = 'bachelor';
                    break;
                    case 'Специалист':
                        $studentDegree = 'specialist';
                    break;
                    case 'Магистр':
                        $studentDegree = 'master';
                    break;
                }
                $studentGroupNum = $line[3];
                $studentGradeID = $model->getGradeID($studentGradeNum, $studentDegree);
                Account::instance()->createStudent($lastName, $firstName, $secondName, 
                                                    $studentGradeID, $studentGroupNum, $facultyID);
            }
            $i++;
        }
        return true;
    }

    public function getFaculties() {
        $model = new Model_Admin_Students();
        $faculties = $model->getFaculties();
        $facultiesHandled = array(); $i = 0;
        foreach($faculties as $row)
        {
            $i++;
            $facultiesHandled[$i]['ID'] = $row['FacultyID'];
            $facultiesHandled[$i]['Name'] = $row['FacultyName'];
            $facultiesHandled[$i]['Abbr'] = $row['FacultyAbbr'];
        }
        return $facultiesHandled;
    }
    
    public function getGrades() {
        $model = new Model_Admin_Students();
        $grades = $model->getGrades();
        $gradesHandled = array(); $i = $j = 0; $degree = 'null';
        $degrees = array('bachelor' => 'Бакалавриат', 'specialist' => 'Специалитет', 'master' => 'Магистратура');
        foreach($grades as $row)
        {
            if($degree != $row['Degree'])
            {
                $degree = $row['Degree'] ;
                $i++; $j = 0;
            }
            $j++;
            $gradesHandled[$i]['Title'] = $degrees[$row['Degree']];
            $gradesHandled[$i]['Grades'][$j]['ID'] = $row['GradeID'];
            $gradesHandled[$i]['Grades'][$j]['Num'] = $row['Grade'];
        }
        return $gradesHandled;
    }    
}
            